use crate::resources::Resources;
use crate::{graphics, input, systems};
use bracket_lib::prelude::*;
use hecs::World;

pub struct State {
    world: World,
    resources: Resources,
}

impl GameState for State {
    fn tick(&mut self, bterm: &mut BTerm) {
        input::handle(&mut self.world, &mut self.resources, bterm);
        systems::run(&mut self.world, &mut self.resources);
        graphics::draw(&self.world, &mut self.resources, bterm);
    }
}

impl State {
    pub fn new(world: World, resources: Resources) -> Self {
        State { world, resources }
    }
}
